﻿Imports System.Collections.Generic
Imports System.Net
Imports System.Web
Imports System.Web.Routing

Public Class ListaNegraModel
    Implements IRouteConstraint
    Public Function Match(ByVal httpContext As System.Web.HttpContextBase, ByVal route As System.Web.Routing.Route, ByVal parameterName As String, ByVal values As System.Web.Routing.RouteValueDictionary, ByVal routeDirection As System.Web.Routing.RouteDirection) As Boolean Implements System.Web.Routing.IRouteConstraint.Match
        Dim taNaListaNegra As Boolean = False

        'voce pode pegar os dados da lisat negra em um banco de dados
        'lista de endereços ip
        Dim _ipListaNegra As New List(Of String)() From { _
         "127.0.0.1", _
         "192.168.1.100", _
         "192.168.1.101", _
         "192.168.1.107", _
         "192.168.1.108" _
        }

        'lista de usuários
        Dim _usernameListaNegra As New List(Of String)() From { _
         "macoratti", _
         "anonymous" _
        }

        'lista de emails
        Dim _emailListaNegra As New List(Of String)() From { _
         "macoratti@yahoo.com", _
         "teste@hotmail.com" _
        }

        'verifica ip na lista
        If _ipListaNegra.Contains(httpContext.Request.UserHostAddress) Then
            values.Add("Motivo", "Seu IP esta na lista Negra: " & Convert.ToString(httpContext.Request.UserHostAddress))
            taNaListaNegra = True
        End If

        'verifica usuário na lista
        If httpContext.Profile IsNot Nothing AndAlso _usernameListaNegra.Contains(httpContext.Profile.UserName.ToLower()) Then
            values.Add("Motivo", "Seu usuário esta na lista Negra: " & httpContext.Profile.UserName.ToLower())
            taNaListaNegra = True
        End If

        'verifica endereço de email
        If _emailListaNegra.Contains("values['email'].ToString()") Then
            values.Add("Motivo", "Seu endereço de email esta na lista Negra: values['email'].ToString()")
            taNaListaNegra = True
        End If

        If taNaListaNegra Then
            'se você quiser despachar o usuário...
            'httpContext.Response.Redirect("http://www.macoratti.net")

            'define o código do status para acesso negado
            httpContext.Response.StatusCode = CInt(HttpStatusCode.Forbidden)
        End If

        'retorna o resultado
        Return taNaListaNegra
    End Function
End Class
